//
//  ImageLoader.h
//  Photogether
//
//  Created by Eson Yu on 19/9/11.
//  Copyright 2011 HA. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ImageIcon.h"


@protocol ImageLoaderDelegate;

@interface ImageLoader : NSObject
{
    NSIndexPath *indexPathInTableView;
    NSMutableData *activeDownload;
    NSURLConnection *imageConnection;
    UIImage *img;
    
    id <ImageLoaderDelegate> delegate;
}

@property (nonatomic, retain) NSIndexPath *indexPathInTableView;
@property (nonatomic, retain) NSMutableData *activeDownload;
@property (nonatomic, retain) NSURLConnection *imageConnection;
@property (nonatomic, retain) UIImage *img;
@property (nonatomic, assign) id <ImageLoaderDelegate> delegate;


- (void)startDownload: (ImageIcon *) appIcon;
- (void)cancelDownload;


@end


@protocol ImageLoaderDelegate 

- (void)appImageDidLoad:(NSIndexPath *)indexPath setImg:(UIImage *)img;


@end