//
//  CoreLocation.m
//  Photogether
//
//  Created by Eson Yu on 1/10/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "CoreLocation.h"

@implementation CoreLocation

@synthesize locMgr;
@synthesize delegate;

- (id)init {
	self = [super init];
    
	if(self != nil) {
		self.locMgr = [[[CLLocationManager alloc] init] autorelease]; // Create new instance of locMgr
		self.locMgr.delegate = self; // Set the delegate as self.
	}
    
	return self;
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
	if([self.delegate conformsToProtocol:@protocol(CoreLocationControllerDelegate)]) {  // Check if the class assigning itself as the delegate conforms to our protocol.  If not, the message will go nowhere.  Not good.
		[self.delegate locationUpdate:newLocation];
	}
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error {
	if([self.delegate conformsToProtocol:@protocol(CoreLocationControllerDelegate)]) {  // Check if the class assigning itself as the delegate conforms to our protocol.  If not, the message will go nowhere.  Not good.
		[self.delegate locationError:error];
	}
}

- (void)locationManager:(CLLocationManager *)manager didUpdateHeading:(CLHeading *)newHeading{
    if([self.delegate conformsToProtocol:@protocol(CoreLocationControllerDelegate)]){
        
        if( newHeading.headingAccuracy > 0){
            [self.delegate locationCompass:newHeading ];
        }
    }
}

- (void)dealloc {
    [super dealloc];
    [locMgr release];
}


@end
