//
//  ImageLoader.m
//  Photogether
//
//  Created by Eson Yu on 19/9/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "ImageLoader.h"
#import "ImageIcon.h"

@implementation ImageLoader


@synthesize indexPathInTableView;
@synthesize activeDownload;
@synthesize imageConnection;
@synthesize img;
@synthesize delegate;


- (void)startDownload :(ImageIcon *) appIcon
{
    indexPathInTableView = appIcon.tableIndexPath;
    NSString *imgUrl = @"http://www.photogether.co/imageview/";
    
    NSString *imgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,@"mobile",appIcon.o_id,appIcon.m_id, @"view.htm"];
    NSURL *imageURL = [NSURL URLWithString:imgFullURL];
    
    //NSLog(@"%@", imgFullURL);
    
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:imageURL];
    [request setHTTPMethod:@"GET"];

    
    self.activeDownload = [NSMutableData data];
    // alloc+init and start an NSURLConnection; release on completion/failure
    NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    self.imageConnection = conn;
    [conn release];
}

- (void)cancelDownload
{
    [self.imageConnection cancel];
    self.imageConnection = nil;
    self.activeDownload = nil;
}


#pragma mark -
#pragma mark Download support (NSURLConnectionDelegate)

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [self.activeDownload appendData:data];
    //NSLog(@"data arrived");
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
	// Clear the activeDownload property to allow later attempts
    self.activeDownload = nil;
    
    // Release the connection now that it's finished
    self.imageConnection = nil;
     NSLog(@"data error");
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    // Set appIcon and clear temporary data/image
    UIImage *loadedImg = [[UIImage alloc] initWithData:self.activeDownload];
        
    self.activeDownload = nil;

    //NSLog(@"data finished.");
    
    // Release the connection now that it's finished
    self.imageConnection = nil;
    
    // call our delegate and tell it that our icon is ready for display
    [delegate appImageDidLoad:self.indexPathInTableView setImg:loadedImg];
    [loadedImg release];
}


@end
