//
//  Location.m
//  Photogether
//
//  Created by Eson Yu on 30/9/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "Location.h"

@implementation Location

@synthesize myMapView;
@synthesize coreLocation;


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    
    /*
    myMapView = [[MKMapView alloc] initWithFrame:self.view.bounds]; 
    myMapView.delegate=self; 
    
    [self.view addSubview:myMapView]; 
    [NSThread detachNewThreadSelector:@selector(displayMYMap) toTarget:self withObject:nil]; 
    */
    [self displayMYMap];
    
    //locat current location
    coreLocation = [[CoreLocation alloc] init];
	coreLocation.delegate = self;
	
    [coreLocation.locMgr startUpdatingLocation];
    [coreLocation.locMgr startUpdatingHeading];
}

- (void)locationUpdate:(CLLocation *)location {
    
    /*
     
     The CLLocation object contains several properties containing location details. These properties are:
     altitude – type CLLocationDistance
     coordinate – type CLLocationCoordinate2D
     course – type CLLocationDirection
     horizontalAccuracy – type CLLocationAccuracy
     speed – type CLLocationSpeed
     timestamp – type NSDate
     verticalAccuracy – type CLLocationAccuracy
     
     
     */
    
    
	//locationLabel.text = [location description];
    speed.text = [NSString stringWithFormat:@"SPEED: %f", [location speed]];
	latitude.text = [NSString stringWithFormat:@"LATITUDE: %f", location.coordinate.latitude];
	longitude.text = [NSString stringWithFormat:@"LONGITUDE: %f", location.coordinate.longitude];
	altitude.text = [NSString stringWithFormat:@"ALTITUDE: %f", [location altitude]];
    
}

- (void)locationCompass:(CLHeading *)heading{
    
    course.text = [NSString stringWithFormat:@"COURSE: %f", [heading magneticHeading]]  ;
    
    //rotate the map
    double headingInRadians = heading.trueHeading * M_PI / 180.0;
    myMapView.transform = CGAffineTransformMakeRotation(headingInRadians);
    
}

- (void)locationError:(NSError *)error {
	//locationLabel.text = [error description];
    speed.text = [error description];
}

-(void)displayMYMap
{
    MKCoordinateRegion region; 
    MKCoordinateSpan span; 
    span.latitudeDelta=0.2; 
    span.longitudeDelta=0.2; 
    
    CLLocationCoordinate2D location; 
    
    location.latitude = 22.377110;
    location.longitude = 114.174789;
    
    
    region.span=span; 
    region.center=location; 
    
    [myMapView setRegion:region animated:TRUE]; 
    [myMapView regionThatFits:region]; 
}

-(IBAction)backBtn:(id)sender{
    
    [self dismissModalViewControllerAnimated:NO];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}
- (void)dealloc {
    [super dealloc];
    [myMapView release];
    [coreLocation release];
}

@end