//
//  CreateOccassion.m
//  Photogether
//
//  Created by Eson Yu on 2/9/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "CreateOccassion.h"
#import "Photogether.h"

static const CGFloat CONTENT_X = 0.0;
static const CGFloat CONTENT_Y = 49.0;
static const CGFloat CONTENT_WIDTH = 320.0;
static const CGFloat CONTENT_HEIGHT = 411.0;
static const CGFloat CONTENT_OFFSET = 70;

@implementation CreateOccassion

-(IBAction)pickerBtnSelected:(id)sender
{
    //NSLog(@"picker selected");
    
    [occPickerView setHidden:true];
    [pickerSelected setEnabled:false];

    [content setFrame:CGRectMake(CONTENT_X, CONTENT_Y, CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setContentSize:CGSizeMake(CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setScrollsToTop:YES];

}

-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return YES;
}

-(void)textViewDidBeginEditing:(UITextView *)textView
{
    
    [content setFrame:CGRectMake(CONTENT_X, CONTENT_Y, CONTENT_WIDTH, 200)];
    [content setContentSize:CGSizeMake(CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setContentOffset:CGPointMake(0, CONTENT_OFFSET) animated:YES];
}

-(void)textViewDidEndEditing:(UITextView *)textView
{
    
    [content setFrame:CGRectMake(CONTENT_X, CONTENT_Y, CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setContentSize:CGSizeMake(CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setScrollsToTop:YES];
}

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView;
{
    return 1;
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    privacy.text=    [arrayNo objectAtIndex:row];
    
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component;
{
    return [arrayNo count];
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component;
{
    return [arrayNo objectAtIndex:row];
}

-(IBAction)occasionPicker:(id)sender
{
    
    //NSLog(@"clicked.....");
    [occText resignFirstResponder];
    [desc resignFirstResponder];
    
    //CGRect pickerRect = CGRectMake(0, 244, 320, 216);
    //[occPickerView setBounds:pickerRect];
    [occPickerView setHidden:FALSE];
    [pickerSelected setEnabled:true];
    
    [content setFrame:CGRectMake(CONTENT_X, CONTENT_Y, CONTENT_WIDTH, 200)];
    [content setContentSize:CGSizeMake(CONTENT_WIDTH, CONTENT_HEIGHT)];
    [content setContentOffset:CGPointMake(0, 166) animated:YES];
   
}

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
           
        if( [response respondsToSelector:@selector(statusCode)] )
        {
            int statusCode = [(NSHTTPURLResponse *) response statusCode];
            //NSDictionary *allheader = [(NSHTTPURLResponse *) response allHeaderFields];
            /*
            if ([response respondsToSelector:@selector(allHeaderFields)])
            {
                
                for (id key in allheader) {
                    
                    NSLog(@"key: %@, value: %@", key, [allheader objectForKey:key]);
                    
                }
                                
                
            }
             */
            if( statusCode == 200 )
            {
                //  success
                NSLog(@"create success: 200");
                
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Create Occasion Completed!" 
                                                               delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                [alert show];
                [alert release];                
                
            }else
            {
                // login failure
                NSLog(@"create failure code : %i", statusCode);
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Create Occasion Failure!" 
                                                               delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
                [alert show];
                [alert release];        
                
            }
            
        }
        
    
}



- (IBAction)newOccasion:(id)sender
{
    //NSLog(@"%@%@%@", occText.text, privacy.text, desc.text);
    
    //NSError *error;
    //NSURLResponse *response;
    NSString *urlSt = @"http://www.photogether.co/occasion/new.htm";
    
    NSLog(@"new occasion clicked");
    
    //collaborators
    NSString *post =[[NSString alloc] initWithFormat:@"newoccassion=%@&privacy=%@&description%@",occText.text,privacy.text,desc.text];
    NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    
    
    /*
    NSURLConnection *conn =[[NSURLConnection alloc] initWithRequest:request delegate:self];
    
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];  
    NSString *returnStr = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    
    NSLog(returnStr);
    */
    
    
    NSString *postLength = [NSString stringWithFormat:@"%d", [postData length]];
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:urlSt]];
    [request setHTTPMethod:@"POST"];
    [request setValue:postLength forHTTPHeaderField:@"Content-Length"];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    [request setHTTPBody:postData];
    //[request setTimeoutInterval:30.0];
    
    NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    [conn release];
    request = nil;
    postData = nil;
    


}

- (IBAction)backAction:(id)sender
{
    [self dismissModalViewControllerAnimated:NO];
}


- (IBAction)backgroundTouched:(id)sender
{
    [occText resignFirstResponder];
    [privacy resignFirstResponder];
    [desc resignFirstResponder];
    [occPickerView setHidden:true];
}



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    arrayNo = [[NSMutableArray alloc] init];
    
    //load 
    [arrayNo addObject:@"PUBLIC"];
    [arrayNo addObject:@"PRIVATE"];
    
    [occPickerView selectRow:1 inComponent:0 animated:NO];
    privacy.text= [arrayNo objectAtIndex:[occPickerView selectedRowInComponent:0]];    

    
    Photogether *photogether = [[Photogether alloc] init];
    [profile setImage:[photogether loadProfilePic:[[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername" ]] ];
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    //[content setContentSize: CGSizeMake(320, 360)];
    
    arrayNo = nil;
    [occPickerView release];
    
    
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
