//
//  MainUIViewController.m
//  Photogether
//
//  Created by Kwong Fai Yu on 22/8/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "DashBoardUIViewController.h"
#import "MomentUIViewController.h"
#import "OccasionUIViewController.h"
#import "OccassionDetailsUIView.h"
#import "UploadUIView.h"
#import "SBJson.h"
#import "Photogether.h"
#import "Location.h"


@implementation DashBoardUIViewController

- (void)uploadPic
{
    //process to other view
    UIImage *img = [UIImage imageNamed:@"IMG_0400.JPG"];
   
    UploadUIView *uploadUIView = [[UploadUIView alloc] initWithNibName:@"UploadUIView" bundle:nil];
    [self presentModalViewController:uploadUIView animated:NO];
    [uploadUIView setImage:img];
    
}


- (void)useCamera
{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera])
    {
        UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
        imagePicker.delegate = self;
        imagePicker.sourceType = UIImagePickerControllerSourceTypeCamera;
        imagePicker.mediaTypes = [NSArray arrayWithObjects:(NSString *) kUTTypeImage,nil];
        imagePicker.allowsEditing = NO;
        [self presentModalViewController:imagePicker animated:YES];
        [imagePicker release];
        newMedia = YES;
    }
}

- (void)useCameraRoll
{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum])
    {
        UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
        imagePicker.delegate = self;
        imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        imagePicker.mediaTypes = [NSArray arrayWithObjects:(NSString *) kUTTypeImage,nil];
        imagePicker.allowsEditing = NO;
        [self presentModalViewController:imagePicker animated:YES];
        [imagePicker release];
        newMedia = NO;
    }
}

-(void)imagePickerController:(UIImagePickerController *)picker 
       didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    NSString *mediaType = [info objectForKey:UIImagePickerControllerMediaType];
    [self dismissModalViewControllerAnimated:NO];
    if ([mediaType isEqualToString:(NSString *)kUTTypeImage]) 
    {
        UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
        
        //cameraPicView.image = image;
        
        // by taking photo from camera
        if (newMedia)
        {
            //save to album
            //UIImageWriteToSavedPhotosAlbum(image, self, @selector(image:finishedSavingWithError:contextInfo:),nil);
        }
        else
        {
            //when pic load from album
            //nothing
        }
        
        //process to other view
        UploadUIView *uploadUIView = [[UploadUIView alloc] initWithNibName:@"UploadUIView" bundle:nil];
        [self presentModalViewController:uploadUIView animated:NO];
        [uploadUIView setImage:image];
        
        //[image release];

    }
    else if ([mediaType isEqualToString:(NSString *)kUTTypeMovie])
    {
		// Code here to support video if enabled
	}
}

-(void)image:(UIImage *)image finishedSavingWithError:(NSError *)error 
    contextInfo:(void *)contextInfo
{
    if (error) {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle: @"Save failed"
                              message: @"Failed to save image"
                              delegate: nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];
        [alert release];
    }
}

-(void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [self dismissModalViewControllerAnimated:NO];
}



-(IBAction)logout
{
    //clear default user session on phone
    [[NSUserDefaults standardUserDefaults] setObject:nil forKey:@"PTusername"];
    [[NSUserDefaults standardUserDefaults] setObject:nil forKey:@"PTisAuthenticated"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    //clear web session
    
    //NSError *error;
    //NSURLResponse *response;
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:@"http://www.photogether.co/logout.htm"]];
    [request setHTTPMethod:@"GET"];
    //[request setTimeoutInterval:30.0];
    
    NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    
    //NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];  
    //NSString *result = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    //NSLog(@"Response Code: %d", [response statusCode]);
    
    /*
    if ([response statusCode] >= 200 && [response statusCode] < 300) {
        NSLog(@"Response: %@", result);
        
    }
     */

    [conn release];
    

    
}

-(IBAction) resignResponse:(id) sender{
    [txtView resignFirstResponder];
    [txt resignFirstResponder];
}


-(IBAction) backAction:(id) sender{
	
    //logout session
    [self logout];
    [self dismissModalViewControllerAnimated:NO];
    
    
}

-(IBAction) changeMsg:(NSString *)str
{
    username.text = str;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
    [photogether release];
    
    [imgView release];
    [scrollView release];
    
    [cameraPicView release];    
}


- (void)nextAnimation 
{
    
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    if( (currentIndex%2)==0 )
    {
        //background A
        backgroundA.image = [backgroundImageQueue objectAtIndex:currentIndex ];
        
    }else{
        //background B
        backgroundB.image = [backgroundImageQueue objectAtIndex:currentIndex ];
    }
    
    currentIndex++;
    if( currentIndex > [backgroundImageQueue count] -1 ){
        currentIndex = 0;
    }
    NSTimeInterval duration = 10.0;
    
    [UIView beginAnimations:@"fade" context:NULL];
    
    [UIView setAnimationDuration:duration];
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(nextAnimation)];
    if( backgroundA.alpha > 0.0 ){
        backgroundA.alpha = 0.0;
        backgroundB.alpha = 1.0;
    }else{
        backgroundA.alpha = 1.0;
        backgroundB.alpha = 0.0;
        
    }
    
    [UIView commitAnimations];
    [pool release];
    
}



#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    [username setText: [[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername"]];
    
    photogether = [[Photogether alloc] init];
    [imgView setImage:[photogether loadProfilePic:username.text]];
    
    //load thumbnail
    //[self loadThumbnailAction];
    
    
    [self performSelectorInBackground:@selector(loadThumbnailAction) withObject:nil]; 
    
    /*
    NSOperationQueue *queue = [NSOperationQueue new];
    NSInvocationOperation *operation = [[NSInvocationOperation alloc] initWithTarget:self
                                                                            selector:@selector(loadThumbnailAction)
                                                                              object:nil];
    
    [queue addOperation:operation];
    [operation release];

    */
    
    firstTwoPicDone = false;
    currentIndex = 1;
    backgroundA.frame =CGRectMake(0, 49, 320, 368);
    backgroundB.frame =CGRectMake(0, 49, 320, 368);
    [backgroundA setContentMode:UIViewContentModeScaleAspectFill];
    [backgroundB setContentMode:UIViewContentModeScaleAspectFill];
    
    backgroundA.alpha = 1.0;
    backgroundB.alpha = 0.0;
    
    backgroundImageQueue = [[NSMutableArray alloc] init];
    
    
    
}

-(IBAction)showActionSheet:(id)sender 
{
    
    UIActionSheet *popupQuery = [[UIActionSheet alloc] initWithTitle:nil delegate:self cancelButtonTitle:@"Cancel" destructiveButtonTitle:nil otherButtonTitles:@"Take Photo", @"Choose From Album", nil];
    popupQuery.actionSheetStyle = UIActionSheetStyleBlackOpaque;
    [popupQuery showInView:self.view];
    [popupQuery release];
}

-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {

    if (buttonIndex == 0) {
        //self.label.text = @"take photo Button Clicked";
        NSLog(@"0 clicked");
        
        [self useCamera];
        //[self uploadPic];
        
    } else if (buttonIndex == 1) {
        //self.label.text = @"choose from album Button Clicked";
        NSLog(@"1 clicked");
        
        [self useCameraRoll];
        //[self uploadPic];
        
    } else if (buttonIndex == 2) {
        //self.label.text = @"Cancel Button Clicked";
        NSLog(@"cancel clicked");

    }
}


-(IBAction)loadThumbnail:(id)sender
{
    [self loadThumbnailAction];
    
}

-(void)addPicToView:(NSArray *)picValue
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
    NSString *picType = @"thumbnail";
    NSString *orgType = @"mobile";
    float imgSize = 73.0f;
    
    NSString *o_id = [picValue objectAtIndex:0];
    NSString *m_id = [picValue objectAtIndex:1];
    
    //NSString *xStr = [picValue objectAtIndex:2];
    //NSString *yStr = [picValue objectAtIndex:3];
    
    NSString *topic = [picValue objectAtIndex:2];
    
    //float x = [xStr floatValue];
    //float y = [yStr floatValue];

    NSString *imgUrl = @"http://www.photogether.co/imageview/";
    NSString *imgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,picType,o_id,m_id, @"view.htm"];
    NSString *orgImgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,orgType,o_id,m_id, @"view.htm"];
    
    //NSLog(@"%@", imgFullURL);
    //NSURL * imageURL = [NSURL URLWithString:imgFullURL];
    NSURL * imageURL = [NSURL URLWithString:orgImgFullURL];
    NSData * imageData = [NSData dataWithContentsOfURL:imageURL];
    UIImage * image = [UIImage imageWithData:imageData];
    
    
    //load to scrollview
    /*
    UIButton *imgBtn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
    
    CGRect imgFrame = CGRectMake(x, y,imgSize, imgSize);
    imgBtn.frame = imgFrame;
    imgBtn.backgroundColor = [UIColor clearColor];
    [imgBtn setBackgroundImage:image forState:UIControlStateNormal];
    [imgBtn addTarget:self action:@selector(loadOccasionDetails:) forControlEvents:UIControlEventTouchUpInside];
    imgBtn.titleLabel.text = o_id;
    [imgBtn setEnabled:TRUE];
    
    [scrollView addSubview:imgBtn];
    */
    
    //load to array
    [backgroundImageQueue addObject:image];
    
    
    if( [backgroundImageQueue count] == 3 )
        firstTwoPicDone = true;
    else
        firstTwoPicDone = false;
    
    //start show the pic
    if( [backgroundImageQueue count] > 1 && firstTwoPicDone ){
        
         //[backgroundImageQueue addObject:[UIImage imageNamed:@"IMG_0400.JPG"]];
         //[backgroundImageQueue addObject:[UIImage imageNamed:@"IMG_0402.JPG"]];
         
         //add more image ot the queue
         backgroundA.image = [backgroundImageQueue objectAtIndex:0 ];
         backgroundB.image = [backgroundImageQueue objectAtIndex:1 ];
        
        
        [self performSelectorInBackground:@selector(nextAnimation) withObject:nil];
    }
    
    [pool release];
}

-(void) loadThumbnailAction
{
        
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    //load occasions' first pic
    float x = 5.0f;
    float y = 11.0f;

    NSString *occ_json = [photogether getJSON:@"http://www.photogether.co/mobile/occasions.htm"];
    
    /*
    NSString *url = @"http://www.photogether.co/mobile/occasions.htm";
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:url]];
    [request setHTTPMethod:@"GET"];
    
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];  
    NSString *occ_json = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    */
    //NSLog(@"%@", occ_json);
    
    
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:occ_json error:nil];
    
    NSInteger row = [statuses count] / 4 + 1 ;
    
    for (NSDictionary *occ_status in statuses)
    {
        
        NSString *o_id = [occ_status objectForKey:@"id"];
        NSString *o_topic = [occ_status objectForKey:@"occasionTopic"];
        NSArray *m_array = [occ_status objectForKey:@"mostViewMomentIds"];
        NSNumber *num_moment = [occ_status objectForKey:@"numOfMomentsUploaded"];

        
        NSString *m_id = @"0";
        if( m_array != [NSNull null] )
        {               
            //NSLog(@"%@", [m_array objectAtIndex:0]);
            m_id = [m_array objectAtIndex:0];
        }
        
        //load the first pic
        //NSString *m_id = [moment objectForKey:@"id"];
        
        //NSArray *picValue = [[NSArray alloc] initWithObjects:o_id,m_id,[[NSString alloc] initWithFormat:@"%f", x],[[NSString alloc] initWithFormat:@"%f", y], nil];
        
        NSArray *picValue = [[NSArray alloc] initWithObjects:o_id,m_id,o_topic, nil];
        
        /*
        NSOperationQueue *queue = [NSOperationQueue new];
        NSInvocationOperation *operation = [[NSInvocationOperation alloc] initWithTarget:self
                                                                                selector:@selector(addPicToView:)
                                                                                  object:picValue];
        [queue addOperation:operation];
        [operation release];
        */
        
        if( m_id != @"0" ){
            [NSThread detachNewThreadSelector:@selector(addPicToView:) 
                                 toTarget:self 
                               withObject:picValue];
        }
        
        picValue = nil;
        m_array = nil;
        o_id = nil;
        
        x = x + 78.0f;
        
        if( x > 250.0f )
        {
            y = y + 78.0f;
            x = 5.0f;
        }
         

       
    }
    
    statuses = nil;
    [parser release];
    occ_json = nil;
    
    CGSize scrollViewContentSize = CGSizeMake(300, (78*row));
    [scrollView setContentSize:scrollViewContentSize ];
    
    
    [pool release];
}


- (void)loadOriginalPic:(id)sender
{
    //NSLog(@"%@", [[sender titleLabel] text]); 
    
    //load the moment View
    MomentUIViewController *momentUIViewController = [[MomentUIViewController alloc] initWithNibName:@"MomentUIViewController" bundle:nil];
    
    
    [self presentModalViewController:momentUIViewController animated:NO];
    
    //[momentUIViewController loadMoments:[[sender titleLabel] text] ] ;
    
    
}


- (void)loadOccasionDetails:(id)sender
{
    //go to occassion details
    /*
    OccassionDetailsUIView *occassionDetailsUIView = [[OccassionDetailsUIView alloc] initWithNibName:@"OccassionDetailsUIView" bundle:nil];
    
    [self presentModalViewController:occassionDetailsUIView animated:NO];
    
    [occassionDetailsUIView setOcc_id:[[sender titleLabel] text]];
*/
    
}


-(IBAction)occasions:(id)sender
{
    //Photogether *photogether = [[[Photogether alloc] init] autorelease];
    //[photogether showLoadingView:self.view];
    
    //load the moment View
    OccasionUIViewController *occasionUIViewController = [[OccasionUIViewController alloc] initWithNibName:@"OccasionUIViewController" bundle:nil];
        
    [self presentModalViewController:occasionUIViewController animated:NO];
    
    //[photogether disposeLoadingView: self.view];
}

-(IBAction)nearByBtn:(id)sender
{
    Location *location = [[Location alloc] initWithNibName:@"Location" bundle:nil];
    [self presentModalViewController:location animated:NO];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [photogether release];
    
    [imgView release];
    [scrollView release];
    
    [cameraPicView release];  
    
    [backgroundA release];
    [backgroundB release];
    backgroundImageQueue = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
