//
//  LoginUIViewController.m
//  Photogether
//
//  Created by Eson YU on 03/08/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LoginUIViewController.h"
#import "DashBoardUIViewController.h"
#import "UploadUIView.h"
#import "MomentUIViewController.h"
#import "CreateOccassion.h"
#import "Photogether.h"
#import "Location.h"


static const CGFloat KEYBOARD_ANIMATION_DURATION = 0.3;
static const CGFloat MINIMUM_SCROLL_FRACTION = 0.2;
static const CGFloat MAXIMUM_SCROLL_FRACTION = 0.8;
static const CGFloat PORTRAIT_KEYBOARD_HEIGHT = 216;
static const CGFloat LANDSCAPE_KEYBOARD_HEIGHT = 162;


bool isLoginPressed = false;
bool isJSON =false;

@implementation LoginUIViewController


-(void)textFieldDidBeginEditing:(UITextField *)textField
{
    CGRect textFieldRect =  [self.view.window convertRect:textField.bounds fromView:textField];
    CGRect viewRect =  [self.view.window convertRect:self.view.bounds fromView:self.view];
    CGFloat midline = textFieldRect.origin.y + 0.5 * textFieldRect.size.height;
    CGFloat numerator =  midline - viewRect.origin.y  - MINIMUM_SCROLL_FRACTION * viewRect.size.height;
    CGFloat denominator =  (MAXIMUM_SCROLL_FRACTION - MINIMUM_SCROLL_FRACTION) * viewRect.size.height;
    CGFloat heightFraction = numerator / denominator;
    if (heightFraction < 0.0)
    {
        heightFraction = 0.0;
    }
    else if (heightFraction > 1.0)
    {
        heightFraction = 1.0;
    }
    UIInterfaceOrientation orientation =
    [[UIApplication sharedApplication] statusBarOrientation];
    if (orientation == UIInterfaceOrientationPortrait ||
        orientation == UIInterfaceOrientationPortraitUpsideDown)
    {
        animatedDistance = floor(PORTRAIT_KEYBOARD_HEIGHT * heightFraction);
    }
    else
    {
        animatedDistance = floor(LANDSCAPE_KEYBOARD_HEIGHT * heightFraction);
    }
    CGRect viewFrame = self.view.frame;
    viewFrame.origin.y -= animatedDistance;
    
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
    
    [self.view setFrame:viewFrame];
    
    [UIView commitAnimations];
    
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
    CGRect viewFrame = self.view.frame;
    viewFrame.origin.y += animatedDistance;
    
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
    
    [self.view setFrame:viewFrame];
    
    [UIView commitAnimations];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    if( textField == password )
        [self login:username.text password:password.text];
    
    return YES;
}


-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    if( isLoginPressed ){
       
    if( [response respondsToSelector:@selector(statusCode)] )
    {
        int statusCode = [(NSHTTPURLResponse *) response statusCode];
        NSDictionary *allheader = [(NSHTTPURLResponse *) response allHeaderFields];
        if ([response respondsToSelector:@selector(allHeaderFields)])
        {
            
            for (id key in allheader) {
                NSLog(@"key: %@, value: %@", key, [allheader objectForKey:key]);
            }
            //NSLog(@"----- %@ ", [allheader objectForKey:@"Isauthenticated"] );
            
            NSString *auth = [allheader objectForKey:@"Isauthenticated"]; 
            if( auth == nil )
            {
                auth = [allheader objectForKey:@"isauthenticated"]; 
            }
            if( auth == nil )
            {
                auth = [allheader objectForKey:@"isAuthenticated"]; 
            }
            
            if( [auth isEqualToString: @"true"] )
            {
                NSLog(@"good");                
                
                NSString *val = nil;
                if (userProfile) {
                    val = [userProfile objectForKey:@"PTusername"];
                    
                    //NSLog(@"%@", val);
                    if( val == nil || val == [NSNull null] || val == @"" ){
                        // saving an NSString
                        [userProfile setObject:username.text forKey:@"PTusername"];
                        [userProfile setObject:password.text forKey:@"PTpassword"];
                        val = username.text;
                    }else{
                        NSLog(@"val = %@", val);
                    }
                }
                
                NSLog(@"user logon: %@", val);
                
                //forward to MainUIView
                
                DashBoardUIViewController *dashBoardUIViewController = [[DashBoardUIViewController alloc] initWithNibName:@"DashBoardUIViewController" bundle:nil];
                [dashBoardUIViewController changeMsg:val];
                [self presentModalViewController:dashBoardUIViewController animated:NO];
                
                
                
            }else{
                NSLog(@" No good");
            }
            
            
            
            
        }
        if( statusCode == 200 )
        {
            // login success
            NSLog(@"Login success: 200");
            
        }else
        {
            // login failure
            NSLog(@"Login code : %i", statusCode);
            
        }
        
        allheader = nil;
        
    }
        
    }
    isLoginPressed = false;
     
    //UIView *loadingView = [[self view] viewWithTag:999];
    [photogether disposeLoadingView: self.view];
    
    
      
}

-(IBAction)login:(NSString *)usr password:(NSString *)pwd
{
    isLoginPressed = true;
    
    [photogether showLoadingView:self.view];
    
        
    NSString *post=[NSString stringWithFormat:@"j_username=%@&j_password=%@", usr, pwd];
    NSLog(@"post string is :%@",post);
    
    NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    
    NSString *postLength = [NSString stringWithFormat:@"%d", [postData length]];
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:@"http://www.photogether.co/j_spring_security_check"]];
    [request setHTTPMethod:@"POST"];
    [request setValue:postLength forHTTPHeaderField:@"Content-Length"];
    [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
    [request setHTTPBody:postData];
    //[request setTimeoutInterval:30.0];
    
    NSURLConnection *conn  = [[NSURLConnection alloc] initWithRequest:request delegate:self];
    
    
    //request = nil;
    //postData = nil;
    //[conn release];
    
}

-(IBAction)loginAction:(id)sender
{
    [self login:username.text password:password.text];
    
    //forward to MainUIView
    /*
    DashBoardUIViewController *dashBoardUIViewController = [[DashBoardUIViewController alloc] initWithNibName:@"DashBoardUIViewController" bundle:nil];
    [self presentModalViewController:dashBoardUIViewController animated:NO];
    */
}

-(IBAction)registerAction:(id)sender
{
    //nothing
    //CreateOccassion *createOccassion = [[CreateOccassion alloc] initWithNibName:@"CreateOccassion" bundle:nil];
    //[self presentModalViewController:createOccassion animated:NO];
    
    /*
    UploadUIView *uploadUIView = [[UploadUIView alloc] initWithNibName:@"UploadUIView" bundle:nil];
    
    [self presentModalViewController:uploadUIView animated:NO];
    [uploadUIView setImage:[UIImage imageNamed:@"P8270051_2.jpg"]];
    */
    //NSLog(@"reg.....");
    //MomentUIViewController *momentUIViewController = [[MomentUIViewController alloc] initWithNibName:@"MomentUIViewController" bundle:nil];
    //[self presentModalViewController:momentUIViewController animated:NO];
   
    //testing
    
    
    //ImageFadeIn *test = [[ImageFadeIn alloc] initWithNibName:@"ImageFadeIn" bundle:nil];
    //[self presentModalViewController:test animated:NO];
    
    Location *location = [[Location alloc] initWithNibName:@"Location" bundle:nil];
    [self presentModalViewController:location animated:NO];

    
    
}

-(IBAction)backgroundTouched:(id)sender
{
    [username resignFirstResponder];
	[password resignFirstResponder];
}
-(IBAction)passwordReturn:(id)sender
{
    [self login:username.text password:password.text];
	[password resignFirstResponder];
    
    
}



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
    [photogether release];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
    
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    //[super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    photogether = [[Photogether alloc] init];
    
    
    userProfile = [NSUserDefaults standardUserDefaults];
    NSString *val = nil;
    
    
    
    if (userProfile) {
        val = [userProfile objectForKey:@"PTusername"];
        
        NSLog(@"%@", val);
        if( val != nil){
            
            //[photogether doLogin:val];
            
            //check login
            BOOL result = [photogether checkLogin];
            //BOOL result = true;
            if( result ){
                //forward to MainUIView
                DashBoardUIViewController *dashBoardUIViewController = [[DashBoardUIViewController alloc] initWithNibName:@"DashBoardUIViewController" bundle:nil];
                [dashBoardUIViewController changeMsg:val];
                [self presentModalViewController:dashBoardUIViewController animated:NO];
     
            }else{
                //auto login
                [self login:[userProfile objectForKey:@"PTusername"] password:[userProfile objectForKey:@"PTpassword"]];
            }
        }
    }
    
    
    
    
    
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [photogether release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
