//
//  MomentUIViewController.m
//  Photogether
//
//  Created by Eson Yu on 28/8/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "MomentUIViewController.h"
#import "Photogether.h"
#import "SBJson.h"

@implementation MomentUIViewController

-(void)initAllMomentsURL:(NSArray *)momentsArr
{
    momentsURL = [momentsArr retain];
}

-(IBAction)fullBtn:(id)sender
{
    [self fullImageView];
}

-(IBAction)leftBtn:(id)sender
{
    NSLog(@"left...");
    
    //NSLog(@"%i  -----", currentPicNum);
    int num = [[NSNumber numberWithInteger:currentPicNum] intValue];

    if( num >= [momentsURL count]-1+1000 )
    {
        num = [momentsURL count];
    }else
    {
        NSString *nextPicURL = [momentsURL objectAtIndex: (num+1-1000) ];
        [self loadMoments: nextPicURL tagNumber:(num+1)];
    }
    
}

-(IBAction)rightBtn:(id)sender
{
    NSLog(@"right...");
    int num = [[NSNumber numberWithInteger:currentPicNum] intValue];
    
    if( num <= 1000 )
    {
        num = 1000;
    }else
    {
        NSString *nextPicURL = [momentsURL objectAtIndex: (num-1-1000) ];
        [self loadMoments: nextPicURL tagNumber:(num-1)];
    }
}

-(void) loadMoments:(NSString *)url tagNumber:(NSInteger *)tag
{
    
    NSLog(@"%@ , %i", url, tag);
    
    //set to current pic
    currentPicNum = tag ;
    
    NSURL * imageURL = [NSURL URLWithString:url];
    NSData * imageData = [NSData dataWithContentsOfURL:imageURL];
    UIImage * image = [UIImage imageWithData:imageData];
    
    
    //pic = [[UIImageView alloc] initWithImage:image];
    //[pic setFrame:CGRectMake(0, 0, 320, 289)];
    //[pic setImage:image];
    [pic setImage:image];
    [pic setContentMode:UIViewContentModeScaleAspectFit];
    
    [image release];
    //imageData = nil;
    //[self.view addSubview:pic];
    
    //remove previous pic
    /*
    for (UIView *subview in picScrollView.subviews) {
        if([subview isKindOfClass:[UIImageView class]])
            [subview removeFromSuperview];
    }
    */
    //[pic setUserInteractionEnabled:YES];
    [picScrollView addSubview:pic];
    
    NSArray *momentList = [url componentsSeparatedByString:@"/"];
    NSLog(@"===%@",[momentList objectAtIndex:momentList.count-2]);
    //load details
    
    NSString *m_id = [momentList objectAtIndex:momentList.count-2];
    NSString *moment_url = [NSString stringWithFormat:@"http://www.photogether.co/mobile/moment/%@.htm", m_id];
    NSString *moment_json = [photogether getJSON:moment_url];
    
    NSLog(@"---%@", moment_json);
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:moment_json error:nil];
        
      
    NSString *m_desc = [statuses valueForKey:@"description"];
    //NSString *m_createdDate = [statuses valueForKey:@"createdDate"];
    NSNumber *m_viewStat = [statuses valueForKey:@"viewStatistics"];
    NSString *m_createdUser = [statuses valueForKey:@"createdUser"];
    NSNumber *m_takenOn = [statuses valueForKey:@"momentTakenOn"];
    NSString *o_id = [statuses valueForKey:@"occasionId"];
    NSString *o_topic = [statuses valueForKey:@"occasionTopic"];  
    
    NSNumber *m_createdDate = [statuses valueForKey:@"createdDate"];
    
   
    if( m_desc == [NSNull null] )
        m_desc = @"";
    if( m_createdDate == [NSNull null] )
        m_createdDate = 0;
    if( m_viewStat == [NSNull null] )
        m_viewStat = 0;
    if( m_createdUser == [NSNull null] )
        m_createdUser = @"";
    if( m_takenOn == [NSNull null] )
        m_takenOn = 0;
    if( o_topic == [NSNull null] )
        o_topic = @"";
    
    //NSDate md = [NSDate dateWithTimeIntervalSince1970: [m_createdDate doubleValue]];
    //NSNumber *time = [NSNumber numberWithDouble:[m_createdDate doubleValue]];
    NSTimeInterval interval = [m_createdDate doubleValue] /1000 ;    
    NSDate *online = [NSDate date];
    online = [NSDate dateWithTimeIntervalSince1970:interval];   

    NSDateFormatter *dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    
    NSString *mdate = [dateFormatter stringFromDate:online];
    NSLog(@"result: %@", mdate);

    
    //time = [NSNumber numberWithDouble:([m_takenOn doubleValue] - 3600*24*365)];
    interval = [m_takenOn doubleValue]/1000;    
    online = [NSDate date];
    online = [NSDate dateWithTimeIntervalSince1970:interval];    
    
    NSString *mtaken = [dateFormatter stringFromDate:online]; 
    NSLog(@"result m - %@", mtaken);
       
    
    desc.text = m_desc;
    createdDate.text = mdate;
    statistics.text = [m_viewStat stringValue];
    owner.text = m_createdUser;
    takenOn.text = mtaken;
    occ_topic.text = o_topic;
    
    statuses = nil;
    [parser release];
    moment_json = nil;
    

}



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)backAction:(id)sender
{
    [self dismissModalViewControllerAnimated:NO];
}


- (void) orientationChanged
{
    UIDeviceOrientation mo = [UIDevice currentDevice].orientation ;
      
    //this part for lanscape
    if ( mo == UIDeviceOrientationLandscapeLeft ) {
        protraitOrNot =false;
        [[UIApplication sharedApplication] setStatusBarHidden:true];
        [self.view setFrame:[[UIScreen mainScreen ] bounds]];
        picDetails.hidden = true; 
        
        // Repositions and resizes the view.
        picScrollView.frame = CGRectMake(0, 0, 480, 320);
        pic.frame = CGRectMake(0, 0, 480, 320);



    }else if ( mo == UIDeviceOrientationLandscapeRight ) {
        
        protraitOrNot = false;
        [[UIApplication sharedApplication] setStatusBarHidden:true];
        [self.view setFrame:[[UIScreen mainScreen ] bounds]];
        picDetails.hidden = true;
        
        // Repositions and resizes the view.
        picScrollView.frame = CGRectMake(0, 0, 480, 320);
        pic.frame = CGRectMake(0, 0, 480, 320);


        
    }else if ( mo == UIDeviceOrientationPortrait  || mo == UIDeviceOrientationPortraitUpsideDown){
    
        protraitOrNot = true;
        [[UIApplication sharedApplication] setStatusBarHidden:false];
        [self.view setFrame:[[UIScreen mainScreen ] bounds]];
        picDetails.hidden = false;
        
        [topBar setFrame:CGRectMake(0, 20, 320, 47)];
        
        // Repositions and resizes the view.
        picScrollView.frame = CGRectMake(0, 64, 320, 332);
        pic.frame = CGRectMake(0, 0, 320, 332);

    }
  
       
        
      
}

- (void)fullImageView
{
    [UIView beginAnimations:@"fullImage" context:nil];
    [UIView setAnimationDuration:0.5];
    
    if( protraitOrNot ){
        
        if( !zoomIn ){
            //hide status bar
            [[UIApplication sharedApplication] setStatusBarHidden:true];
            //[UIApplication sharedApplication].keyWindow.bounds = CGRectMake(0, 0, 320, 480) ;
            self.view.frame = CGRectMake(0, 0, 320, 480);

            //this part is the fullscreen
            //picDetials is the text scroll view 
            //this is protrait view
            
            //zoom in
            [picScrollView setFrame:CGRectMake(0, 0, 320, 480)];
            [pic setFrame:CGRectMake(0, 0, 320, 480)];
            
            [UIView beginAnimations:@"hide" context:nil];
            [UIView setAnimationDuration:0.5];
            
            [picDetails setContentSize:CGSizeZero];
            
            [UIView commitAnimations];
            
            //hide the moment title
            momentTitle.hidden = true;
           
            
            
            
            zoomIn = true;
        }else{
            
            [[UIApplication sharedApplication] setStatusBarHidden:false];
            //[UIApplication sharedApplication].keyWindow.bounds = CGRectMake(0, 20, 320, 460) ;
            self.view.frame = CGRectMake(0, 0, 320, 480);
            

            //zoom out
            [picScrollView setFrame:CGRectMake(0, 64, 320, 289)];
            [pic setFrame:CGRectMake(0, 0, 320, 289)];
            
            [UIView beginAnimations:@"hide" context:nil];
            [UIView setAnimationDuration:0.5];
            
            [picDetails setContentSize:CGSizeMake(320, 128)];
            
            [UIView commitAnimations];

            zoomIn = false;
            
            momentTitle.hidden = false;
            [momentTitle setFrame:CGRectMake(63, 31, 210, 21)];
            
        }
        
    }
    
    [UIView commitAnimations];
    
}




#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    
    protraitOrNot = true;
    zoomIn = false;
    currentPicNum = 1000;
    
    photogether = [[Photogether alloc] init];

    
    [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(orientationChanged) name:UIDeviceOrientationDidChangeNotification object:nil];
        
       
    //[pic setFrame:CGRectMake(0, 0, 320 , 332)];
    //[pic setContentMode:UIViewContentModeScaleAspectFit];
    //pic.userInteractionEnabled = YES;
    //pic.opaque = YES;
   
    [profile setImage:[photogether loadProfilePic:[[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername" ]] ];

    //picScrollView = [[SlideControl alloc] init];
    
           
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [photogether release];
    [[UIDevice currentDevice] endGeneratingDeviceOrientationNotifications];
    [[NSNotificationCenter defaultCenter] removeObject:self];
    
    [picScrollView release];
    [picDetails release];
    [pic release];
    momentsURL = nil;

}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    //return (interfaceOrientation == UIInterfaceOrientationPortrait);
    //return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    return YES;
}


@end
