//
//  OccasionUIViewController.m
//  Photogether
//
//  Created by Eson Yu on 28/8/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "OccasionUIViewController.h"
#import "OccassionDetailsUIView.h"
#import "CreateOccassion.h"
#import "TableCellView.h"
#import "SBJson.h"
#import "Photogether.h"
#import "ImageLoader.h"
#import "ImageIcon.h"

@implementation OccasionUIViewController


@synthesize imageDownloadsInProgress;

- (IBAction)backAction:(id)sender
{
    [self dismissModalViewControllerAnimated:NO];
}

- (IBAction)createOccasion:(id)sender
{
    
    CreateOccassion *createOccassion = [[CreateOccassion alloc] initWithNibName:@"CreateOccassion" bundle:nil];
    [self presentModalViewController:createOccassion animated:NO];
    
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)table {
	return 1;
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return arryData.count;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	  
        
    static NSString *CellIdentifier = @"LazyTableCell";
   	
    TableCellView *cell = (TableCellView *)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil)
	{
        [[NSBundle mainBundle] loadNibNamed:@"TableCellView" owner:self options:nil];
		cell = tblCell;
    }
    
    // Leave cells empty if there's no data yet
    if ([arryData count] > 0)
	{
        UIImage *savedImg = [imageDownloadsInProgress objectForKey:indexPath];
        if (savedImg == nil)
        {
            
            
            [cell setLabelText:[arryData objectAtIndex:indexPath.row]];
            [cell setDescpText:[descpList objectAtIndex:indexPath.row]];
            [cell setOcc_id:[occ_id objectAtIndex:indexPath.row]];
            
            ImageIcon *appIcon = [[ImageIcon alloc] init];
            appIcon.m_id = [moment_id objectAtIndex:indexPath.row];
            appIcon.o_id = [occ_id objectAtIndex:indexPath.row];
            appIcon.tableIndexPath = indexPath;
            
            
            ImageLoader *iconDownloader = [[ImageLoader alloc] init];
            iconDownloader.delegate = self;
            [iconDownloader startDownload:appIcon];
            
            //[iconDownloader release];   
            //[appIcon release];
            
        }else{
            
            //load cached image
            [cell setLabelText:[arryData objectAtIndex:indexPath.row]];
            [cell setDescpText:[descpList objectAtIndex:indexPath.row]];
            [cell setOcc_id:[occ_id objectAtIndex:indexPath.row]];
            [cell setProductImage:[imageDownloadsInProgress objectForKey:indexPath]];
            
            //NSLog(@"loaded cached image");
            
        }
        [savedImg release];
                
    }
    

    return cell;
    
   
    
}


/*
-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    return @"Occasions";
        
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	//go to occassion details
    
    TableCellView *cell = (TableCellView *)[tableView cellForRowAtIndexPath:indexPath];
    NSLog(@"oid - %@", cell.occ_id);
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    OccassionDetailsUIView *occassionDetailsUIView = [[OccassionDetailsUIView alloc] initWithNibName:@"OccassionDetailsUIView" bundle:nil];
    [occassionDetailsUIView setOcc_id:cell.occ_id numOfMoment:[numOfMoment objectAtIndex:indexPath.row ] ];
    
    [self presentModalViewController:occassionDetailsUIView animated:NO];
    
    
    
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        
        //[photogether showLoadingView:self.view];
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)appImageDidLoad:(NSIndexPath *)indexPath setImg:(UIImage *)img
{

    
    TableCellView *cell = (TableCellView *)[occ_tableView  cellForRowAtIndexPath:indexPath];
    UIImage *loadedImag = [img retain];
    [cell setProductImage:loadedImag];
    //NSLog(@"%i", indexPath.row );
    
    if( loadedImag != nil ){
        [imageDownloadsInProgress setObject:loadedImag forKey:indexPath];
    }
}

- (void) loadOccasions
{
    
    
    //NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
    //load occasions' first pic & total moments
    
    NSString *occ_json = [photogether getJSON:@"http://www.photogether.co/mobile/occasions.htm"];
    
    
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:occ_json error:nil];
    
        
    //NSLog(@"%@", occ_json);
    //int picIndex = 0;
    
    for (NSDictionary *occ_status in statuses)
    {
        
        NSString *o_id = [occ_status objectForKey:@"id"];
        NSArray *m_array = [occ_status objectForKey:@"mostViewMomentIds"];
        
        NSString *m_id = @"0";
        if( m_array != [NSNull null] )
        {               
            //NSLog(@"%@", [m_array objectAtIndex:0]);
            m_id = [m_array objectAtIndex:0];
        }

        NSNumber *num_moment = [occ_status objectForKey:@"numOfMomentsUploaded"];
        
        
        [moment_id addObject:m_id];
        //NSLog(@"%i", [num_moment intValue]);
        [occ_id addObject:o_id];
        [arryData addObject:[occ_status objectForKey:@"occasionTopic"]];
        [descpList addObject: [NSString stringWithFormat:@"%i moments", [num_moment intValue]]];
        [numOfMoment addObject:num_moment];
       
        
    }
    
    statuses = nil;
    [parser release];
    occ_json = nil;
    
    //[photogether disposeLoadingView:self.view];
    
    [occ_tableView performSelectorOnMainThread:@selector(reloadData) withObject:nil waitUntilDone:NO];

    //[occ_tableView reloadData];
    //[pool release];

}


#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    photogether = [[Photogether alloc] init];
    
    arryData = [[NSMutableArray alloc] init] ; 
    descpList = [[NSMutableArray alloc] init] ;
    imagesList = [[NSMutableArray alloc] init] ;
    occ_id = [[NSMutableArray alloc] init];
    moment_id = [[NSMutableArray alloc] init];
    numOfMoment = [[NSMutableArray alloc] init];
    
    imageTagNum = 3000;
    
    imageDownloadsInProgress = [[NSMutableDictionary alloc] init];
    
    [username setText: [[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername"]];
    [profile setImage:[photogether loadProfilePic:username.text]];
    
    // Do any additional setup after loading the view from its nib.
    
    //[photogether showLoadingView:self.view];
    //[self performSelector:@selector(loadOccasions) withObject:nil afterDelay:0.4];
    
    //[self loadOccasions];
    
    NSOperationQueue *queue = [NSOperationQueue new];
    NSInvocationOperation *operation = [[NSInvocationOperation alloc] initWithTarget:self
                                                                            selector:@selector(loadOccasions)
                                                                              object:nil];
    [queue addOperation:operation];
    [operation release];
     
        
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    [imageDownloadsInProgress release];

    [photogether release];
    
    arryData =nil ; 
    descpList = nil ;
    imagesList = nil ;
    occ_id = nil;
    moment_id = nil;
    numOfMoment = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
