//
//  OccassionDetailsUIView.m
//  Photogether
//
//  Created by Eson Yu on 30/8/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "OccassionDetailsUIView.h"
#import "OccasionUIViewController.h"
#import "MomentUIViewController.h"
#import "UploadUIView.h"
#import "Photogether.h"
#import "SBJson.h"

@implementation OccassionDetailsUIView


- (void)uploadPic
{
    //process to other view
    UIImage *img = [UIImage imageNamed:@"6.jpg.png"];
    
    UploadUIView *uploadUIView = [[UploadUIView alloc] initWithNibName:@"UploadUIView" bundle:nil];
    [self presentModalViewController:uploadUIView animated:NO];
    [uploadUIView setImage:img];
    
    [img release];
}


- (void)useCamera
{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera])
    {
        UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
        imagePicker.delegate = self;
        imagePicker.sourceType = UIImagePickerControllerSourceTypeCamera;
        imagePicker.mediaTypes = [NSArray arrayWithObjects:(NSString *) kUTTypeImage,nil];
        imagePicker.allowsEditing = NO;
        [self presentModalViewController:imagePicker animated:YES];
        [imagePicker release];
        newMedia = YES;
    }
}

- (void)useCameraRoll
{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum])
    {
        UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
        imagePicker.delegate = self;
        imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        imagePicker.mediaTypes = [NSArray arrayWithObjects:(NSString *) kUTTypeImage,nil];
        imagePicker.allowsEditing = NO;
        [self presentModalViewController:imagePicker animated:YES];
        [imagePicker release];
        newMedia = NO;
    }
}

-(void)imagePickerController:(UIImagePickerController *)picker 
didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    NSString *mediaType = [info objectForKey:UIImagePickerControllerMediaType];
    [self dismissModalViewControllerAnimated:NO];
    if ([mediaType isEqualToString:(NSString *)kUTTypeImage]) 
    {
        UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
        
        //cameraPicView.image = image;
        
        // by taking photo from camera
        if (newMedia)
        {
            //save to album
            //UIImageWriteToSavedPhotosAlbum(image, self, @selector(image:finishedSavingWithError:contextInfo:),nil);
        }
        else
        {
            //when pic load from album
            //nothing
        }
        
        //process to other view
        UploadUIView *uploadUIView = [[UploadUIView alloc] initWithNibName:@"UploadUIView" bundle:nil];
        [self presentModalViewController:uploadUIView animated:NO];
        [uploadUIView setImage:image];
        
        [image release];
        
    }
    else if ([mediaType isEqualToString:(NSString *)kUTTypeMovie])
    {
		// Code here to support video if enabled
	}
}

-(void)image:(UIImage *)image finishedSavingWithError:(NSError *)error 
 contextInfo:(void *)contextInfo
{
    if (error) {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle: @"Save failed"
                              message: @"Failed to save image"
                              delegate: nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];
        [alert release];
    }
}

-(void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [self dismissModalViewControllerAnimated:NO];
}

-(IBAction)showActionSheet:(id)sender 
{
    
    UIActionSheet *popupQuery = [[UIActionSheet alloc] initWithTitle:nil delegate:self cancelButtonTitle:@"Cancel" destructiveButtonTitle:nil otherButtonTitles:@"Take Photo", @"Choose From Album", nil];
    popupQuery.actionSheetStyle = UIActionSheetStyleBlackOpaque;
    [popupQuery showInView:self.view];
    [popupQuery release];
}

-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    
    if (buttonIndex == 0) {
        //self.label.text = @"take photo Button Clicked";
        NSLog(@"0 clicked");
        
        [self useCamera];
        //[self uploadPic];
        
    } else if (buttonIndex == 1) {
        //self.label.text = @"choose from album Button Clicked";
        NSLog(@"1 clicked");
        
        [self useCameraRoll];
        //[self uploadPic];
        
    } else if (buttonIndex == 2) {
        //self.label.text = @"Cancel Button Clicked";
        NSLog(@"cancel clicked");
        
    }
}



-(IBAction)occasions:(id)sender
{
    //load the moment View
    OccasionUIViewController *occasionUIViewController = [[OccasionUIViewController alloc] initWithNibName:@"OccasionUIViewController" bundle:nil];
    
    [self presentModalViewController:occasionUIViewController animated:NO];
}


- (void) setOcc_id:(NSString *)oid numOfMoment:(NSNumber *)num
{
    occ_id = oid;
    numOfMoments = num;
    
    //occ_topic.text = topic;
    
    //[photogether showLoadingView:self.view];
    /*
    //get the occasion topic
    NSString *topicURL = [NSString stringWithFormat:@"http://www.photogether.co/mobile/occasion/%@.htm", oid];
    NSString *occ_json = [photogether getJSON:topicURL];
    
    NSLog(@"%@", occ_json);
    
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:occ_json error:nil];
    
    occ_topic.text = [statuses valueForKey:@"occasionTopic"];
    
    //load thumbnail
    //[self loadThumbnailAction];
    
    //[self performSelector:@selector(loadThumbnailAction) withObject:nil afterDelay:0.3];
    
    //[self performSelectorInBackground:@selector(loadThumbnailAction) withObject:nil];
    */
    /*
    NSOperationQueue *queue = [NSOperationQueue new];
    NSInvocationOperation *operation = [[NSInvocationOperation alloc] initWithTarget:self
                                                                            selector:@selector(loadThumbnailAction)
                                                                              object:nil];
    [queue addOperation:operation];
    [operation release];
    */
    /*[NSThread detachNewThreadSelector:@selector(loadThumbnailAction) 
                             toTarget:self 
                           withObject:nil];
    */
    /*
    statuses = nil;
    [parser release];
    occ_json = nil;
    */
    
}
- (IBAction)backAction:(id)sender
{
    [self dismissModalViewControllerAnimated:NO];
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


-(void)addPicToView:(NSArray *)picValue
{
    //NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
    NSString *picType = @"thumbnail";
    NSString *orgType = @"mobile";
    float imgSize = 73.0f;
    
    NSString *o_id = [picValue objectAtIndex:0];
    NSString *m_id = [picValue objectAtIndex:1];
    
    NSString *tagStr = [picValue objectAtIndex:2];
    NSString *xStr = [picValue objectAtIndex:3];
    NSString *yStr = [picValue objectAtIndex:4];
    
    float x = [xStr floatValue];
    float y = [yStr floatValue];
    int tag = [tagStr intValue];
    
   
    NSString *imgUrl = @"http://www.photogether.co/imageview/";
    NSString *imgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,picType,o_id,m_id, @"view.htm"];
    //NSLog(@"%@",imgFullURL);
    NSString *orgImgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,orgType,occ_id,m_id, @"view.htm"];
    
    NSURL * imageURL = [NSURL URLWithString:imgFullURL];
    NSData * imageData = [NSData dataWithContentsOfURL:imageURL];
    UIImage *image = [UIImage imageWithData:imageData];

    CGImageRef tmp = CGImageCreateWithImageInRect(image.CGImage, CGRectMake(0, 0, 73, 73));
    
    UIButton *imgBtn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
    CGRect imgFrame = CGRectMake(x, y,imgSize, imgSize);
    
    imgBtn.frame = imgFrame;
    //imgBtn.backgroundColor = [UIColor clearColor];
    [imgBtn setBackgroundImage:[UIImage imageWithCGImage:tmp] forState:UIControlStateNormal];
    [imgBtn setContentMode:UIViewContentModeCenter];
    [imgBtn addTarget:self action:@selector(loadOriginalPic:) forControlEvents:UIControlEventTouchUpInside];
    imgBtn.titleLabel.text = orgImgFullURL;
    
    [imgBtn setContentMode:UIViewContentModeScaleAspectFill];
    [imgBtn setClipsToBounds:true];
    
    //add tag number to the button image
    imgBtn.tag = tag;
    [imgBtn setEnabled:TRUE];
    
    /*
    UIButton *imgBtn = [[UIButton buttonWithType:UIButtonTypeCustom] retain] ;
    //[imgBtn setImage:image forState:UIControlStateNormal];
    [imgBtn setBackgroundImage:image forState:UIControlStateNormal];
    CGRect imgFrame = CGRectMake(x, y,imgSize, imgSize);
    imgBtn.frame = imgFrame;
    
    [imgBtn addTarget:self action:@selector(loadOriginalPic:) forControlEvents:UIControlEventTouchUpInside];
    
    imgBtn.titleLabel.text = orgImgFullURL;
    
    //add tag number to the button image
    imgBtn.tag = tagNumber;
    [imgBtn setEnabled:TRUE];

*/
    
    /*
    UIImageView *imgBtn = [[UIImageView alloc] initWithFrame:CGRectMake(x, y, imgSize, imgSize )];
    [imgBtn setContentMode:UIViewContentModeScaleAspectFill];
    [imgBtn setClipsToBounds:YES];
    imgBtn.image = image;
    */
    
    [scrollView addSubview:imgBtn];
    
    //[imgBtn release];
    
    //[pool release];
}


- (void)loadMorePic{
    
    int start= 20*page;
    int numPic = 20;
    
    NSLog(@"start: %i,  numPic: %i", start, numPic);
    
    //load more pic
    [photogether showLoadingView:self.view];
    
    //load all moments for occasion
    //Photogether *photogether = [[Photogether alloc] init];
    //NSString *picType = @"thumbnail";
    NSString *orgType = @"mobile";
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    
    NSString *url = @"http://www.photogether.co/mobile/";
    NSString *fullURL = [NSString stringWithFormat:@"%@%@/moment.htm?s=%i&m=%i",url,occ_id,start,numPic];
    NSString *moment_json = [photogether getJSON:fullURL];
    
    //NSLog(@"%@", moment_json);
    
    NSArray *m_statuses = [parser objectWithString:moment_json error:nil];
    
    NSInteger row = [m_statuses count] / 4 + 1 ;
    
    tagNumber += start;
    
    float x = 5.0f;
    float y = 11.0f + ((row-1) * page * 78.0f);
    
    if( row != 6 ){
        y = 11.0f + 78*5*page;
    }
    
    
    
    for (NSDictionary *m_status in m_statuses)
    {
        
        NSString *m_id = [m_status objectForKey:@"id"];
        NSString *imgUrl = @"http://www.photogether.co/imageview/";
        
        NSString *orgImgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,orgType,occ_id,m_id, @"view.htm"];
        
        //store all moments
        [momentsArr addObject:orgImgFullURL];
        
        //UIImageView * myImageView = [[UIImageView alloc] initWithFrame:CGRectMake(x, y,imgSize, imgSize)];
        //[myImageView setImage:image];
        //[scrollView addSubview:myImageView];
        //[myImageView release];
        
        
        NSArray *picValue = [[NSArray alloc] initWithObjects:occ_id,m_id,[[NSString alloc] initWithFormat:@"%i", tagNumber],[[NSString alloc] initWithFormat:@"%f", x],[[NSString alloc] initWithFormat:@"%f", y], nil];
        
        
        [self addPicToView:picValue];
        picValue = nil;
        
        x = x + 78.0f;
        
        if( x > 250.0f )
        {
            y = y + 78.0f;
            x = 5.0f;
        }
        
        tagNumber += 1;
        
        
    }
    
    page = page + 1;
   
    NSLog(@"row %i, page %i,  total %i", row, (int)page, 78*row*page);
    
    CGSize scrollViewContentSize;
    if( row == 6 ){
        scrollViewContentSize = CGSizeMake(300, 78*5*page + 78 );
    }else{
        scrollViewContentSize = CGSizeMake(300, 78*5*(page-1) + 78*(row) );
    }
    
    [scrollView setContentSize:scrollViewContentSize ];
    
    //for  more pic
    if( [numOfMoments intValue] > (20* (int)page) ){
        NSLog(@"num of moments: %i",[numOfMoments intValue]);
        CGRect imgFrame = CGRectMake(100, 390*page+10 , 100, 30);
        moreBtn.frame = imgFrame;
        [moreBtn setEnabled:TRUE];
    }else{
        [moreBtn setEnabled:FALSE];
        [moreBtn removeFromSuperview];
    }
    
    [photogether disposeLoadingView:self.view];
    m_statuses = nil;
    moment_json = nil;
    
    [parser release];

}

-(void) loadThumbnailAction
{
    //NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
  
    [photogether showLoadingView:self.view];

    //load all moments for occasion
    //Photogether *photogether = [[Photogether alloc] init];
    //NSString *picType = @"thumbnail";
    NSString *orgType = @"mobile";
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    
    NSString *url = @"http://www.photogether.co/mobile/";
    NSString *fullURL = [NSString stringWithFormat:@"%@%@%@",url,occ_id, @"/moment.htm?s=0&m=20"];
    NSString *moment_json = [photogether getJSON:fullURL];
    
    //NSLog(@"%@", moment_json);
    
    NSArray *m_statuses = [parser objectWithString:moment_json error:nil];
    
    NSInteger row = [m_statuses count] / 4 + 1 ;
    
    //start from 1000;
    tagNumber =  1000;
    
    float x = 5.0f;
    float y = 11.0f;
    
    for (NSDictionary *m_status in m_statuses)
    {
        
        NSString *m_id = [m_status objectForKey:@"id"];
        NSString *imgUrl = @"http://www.photogether.co/imageview/";
       
        NSString *orgImgFullURL = [NSString stringWithFormat:@"%@%@/%@/%@/%@",imgUrl,orgType,occ_id,m_id, @"view.htm"];
        
        //store all moments
        [momentsArr addObject:orgImgFullURL];
                
        //UIImageView * myImageView = [[UIImageView alloc] initWithFrame:CGRectMake(x, y,imgSize, imgSize)];
        //[myImageView setImage:image];
        //[scrollView addSubview:myImageView];
        //[myImageView release];
        
        
        NSArray *picValue = [[NSArray alloc] initWithObjects:occ_id,m_id,[[NSString alloc] initWithFormat:@"%i", tagNumber],[[NSString alloc] initWithFormat:@"%f", x],[[NSString alloc] initWithFormat:@"%f", y], nil];
        
        
        /*
         NSOperationQueue *queue = [NSOperationQueue new];
         NSInvocationOperation *operation = [[NSInvocationOperation alloc] initWithTarget:self
         selector:@selector(addPicToView:)
         object:picValue];
         [queue addOperation:operation];
         [operation release];
         */
        
        
        //[NSThread detachNewThreadSelector:@selector(addPicToView:) 
         //                        toTarget:self 
         //                      withObject:picValue];

        [self addPicToView:picValue];
        //[self performSelectorInBackground:@selector(addPicToView:) withObject:picValue];
        picValue = nil;
               
        x = x + 78.0f;
        
        if( x > 250.0f )
        {
            y = y + 78.0f;
            x = 5.0f;
        }
        
        tagNumber += 1;
        
        
    }
    CGSize scrollViewContentSize = CGSizeMake(300, (78*row));
    
    [scrollView setContentSize:scrollViewContentSize ];
    
    //for  more pic
    if( [numOfMoments intValue] > 20 ){
        
        NSLog(@"num of moments: %i",[numOfMoments intValue]);
        
        CGRect imgFrame = CGRectMake(100, 400 , 100, 30);
        moreBtn.frame = imgFrame;
        moreBtn.enabled = true;
        [scrollView addSubview:moreBtn];
    
    }
    
    
    [photogether disposeLoadingView:self.view];
    m_statuses = nil;
    moment_json = nil;
    
    [parser release];
    
    //[pool release];
    
}



- (void)loadOriginalPic:(id)sender
{
    //NSLog(@"%@", [[sender titleLabel] text]); 
    
    //load the moment View
    MomentUIViewController *momentUIViewController = [[MomentUIViewController alloc] initWithNibName:@"MomentUIViewController" bundle:nil];
    
    
    [self presentModalViewController:momentUIViewController animated:NO];
    [momentUIViewController initAllMomentsURL:momentsArr];
    [momentUIViewController loadMoments:[[sender titleLabel] text] tagNumber:[sender tag]] ;
    
    
}


#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    photogether = [[Photogether alloc] init];
    NSString *username = [[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername"];
    [profileImgView setImage:[photogether loadProfilePic:username]];
   
    momentsArr = [[NSMutableArray alloc] init];
    
    page = 1;
    tagNumber =1000;
    
    
    //more button 
    moreBtn = [[UIButton alloc] init];
    CGRect imgFrame = CGRectMake(100, 400, 100, 30);
    moreBtn.frame = imgFrame;
    [moreBtn setTitle:@"More..." forState:UIControlStateNormal];
    [moreBtn setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
    moreBtn.titleLabel.font = [UIFont fontWithName:@"Arial-BoldMT" size:15.0];
    [moreBtn addTarget:self action:@selector(loadMorePic) forControlEvents:UIControlEventTouchUpInside];
    [moreBtn setEnabled:TRUE];
    
    //[photogether showLoadingView:self.view];
    //[self performSelectorInBackground:@selector(loadThumbnailAction) withObject:nil];
    
    [self loadThumbnailAction];
    //[photogether disposeLoadingView:self.view];
    
    
    /*
    [[TTURLRequestQueue mainQueue] setMaxContentLength:0];
    
    TTNavigator *navigator = [TTNavigator navigator];
    navigator.window = scrollView;
    
    TTURLMap *map = navigator.URLMap;
    [map from:@"tt://appPhotos" toSharedViewController:[PhotoViewController class]];
    
    [navigator openURLAction:[TTURLAction actionWithURLPath:@"tt://appPhotos"]];
    
    //[self.view makeKeyAndVisible];
    */
    
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    [photogether release];
    
    momentsArr = nil;
    [profileImgView release];
    [cameraPicView release];
    
    [moreBtn release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
