//
//  PhotogetherMethods.m
//  Photogether
//
//  Created by Eson Yu on 25/8/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "Photogether.h"
#import "PhotogetherAppDelegate.h"
#import "SBJson.h"

@implementation Photogether

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

-(void) doLogin:(NSString *)username
{
    NSString *profileURL = [NSString stringWithFormat:@"http://www.photogether.co/mobile/%@.htm", username];
    NSString *profileStr = [self getJSON:profileURL];    
    NSLog(@"json : %@", profileStr);
    
}

-(UIImage *) loadProfilePic:(NSString *)username
{
    NSString *profileURL = [NSString stringWithFormat:@"http://www.photogether.co/mobile/%@.htm", username];
    NSString *profileStr = [self getJSON:profileURL];    
    NSLog(@"%@", profileStr);
    
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:profileStr error:nil];
        
    //NSLog(@"%@ hash", [statuses valueForKey:@"gravatarHash"]);
    NSString *profileID = [statuses valueForKey:@"gravatarHash"];
    NSString *profileImgURL = [NSString stringWithFormat:@"http://www.gravatar.com/avatar/%@", profileID];
    
    //load profile img
    NSURL * imageURL = [NSURL URLWithString: profileImgURL];
    NSData * imageData = [NSData dataWithContentsOfURL:imageURL];
    UIImage * image = [UIImage imageWithData:imageData];
    
    imageData = nil;
    statuses = nil;
    [parser release];
    return image;
}


-(NSString *) getJSON:(NSString *)url
{
    //load occasions
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:url]];
    [request setHTTPMethod:@"GET"];
    
    NSData *responseData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];  
    NSString *json_string = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    
    request = nil;
    responseData = nil;
    
    return json_string;
    
    //[[NSURLConnection alloc] initWithRequest:request delegate:self];
    //return @"OK";
}

-(BOOL) checkLogin
{
    //load occasions
    //nothing
    BOOL result = false;
    NSError *error;
    NSURLResponse *response;
    NSString *url = @"http://www.photogether.co/index.htm";
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:url]];
    [request setHTTPMethod:@"GET"];
    //[request setTimeoutInterval:30.0];
    
    NSURLConnection *conn = [[NSURLConnection alloc] initWithRequest:request delegate:nil];
    [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];  
    
    if( [response respondsToSelector:@selector(statusCode)] )
    {
        //int statusCode = [(NSHTTPURLResponse *) response statusCode];
        NSDictionary *allheader = [(NSHTTPURLResponse *) response allHeaderFields];
        if ([response respondsToSelector:@selector(allHeaderFields)])
        {
            
            for (id key in allheader) {
                NSLog(@"key: %@, value: %@", key, [allheader objectForKey:key]);
            }
            
            NSString *auth = [allheader objectForKey:@"Isauthenticated"]; 
            if( auth == nil )
            {
                auth = [allheader objectForKey:@"isauthenticated"]; 
            }
            if( auth == nil )
            {
                auth = [allheader objectForKey:@"isAuthenticated"]; 
            }
            
            if( [auth isEqualToString: @"true"] )
            {
                NSLog(@"session valid");                
                result = true;                
            }else{
                NSLog(@"session expired");
                
                [self logout:conn];
                result = false;
            }
            

            
        }
        
        allheader = nil;
    }
  
    //request = nil;
    [conn release];
    
    return result;

}

-(IBAction)logout:(NSURLConnection *)conn
{
    //NSError *error;
    //NSURLResponse *response;
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:@"http://www.photogether.co/logout.htm"]];
    [request setHTTPMethod:@"GET"];
    //[request setTimeoutInterval:30.0];
    
    [conn initWithRequest:request delegate:self];
    
}

-(void)showLoadingView:(UIView *)superView
{
    CGRect frame = CGRectMake(90, 190, 32, 32);
    UIActivityIndicatorView *loadingInd = [[UIActivityIndicatorView alloc] initWithFrame:frame];
    [loadingInd startAnimating];
    loadingInd.activityIndicatorViewStyle = UIActivityIndicatorViewStyleWhiteLarge;
    
    frame = CGRectMake(130, 193, 140, 31);
    UILabel *loadingLabel = [[UILabel alloc] initWithFrame:frame];
    loadingLabel.text = @"Loading...";
    loadingLabel.textColor = [UIColor whiteColor];
    loadingLabel.font = [UIFont fontWithName:@"Gill Sans" size:15  ];
    loadingLabel.backgroundColor = [UIColor clearColor];
    
    frame =[[UIScreen mainScreen] bounds];
    UIView *maskView = [[UIView alloc] initWithFrame:frame];
    maskView.backgroundColor = [UIColor blackColor];
    maskView.alpha = 0.7;
    maskView.tag = 999;
    
    [maskView addSubview:loadingInd];
    [maskView addSubview:loadingLabel];
    
    [loadingInd release];
    [loadingLabel release];
    
    [superView addSubview:maskView];
    [maskView release];
    
    
}

-(void)disposeLoadingView:(UIView *)superView
{
    //[superView removeFromSuperview];
    [[superView viewWithTag:999] removeFromSuperview];
}

@end
