//
//  UploadUIView.m
//  Photogether
//
//  Created by Eson Yu on 29/8/11.
//  Copyright 2011 HA. All rights reserved.
//

#import "UploadUIView.h"
#import "Photogether.h"
#import "SBJson.h"

@implementation UploadUIView

-(IBAction)pickerBtnSelected:(id)sender
{
    //NSLog(@"picker selected");
    
    [occPickerView setHidden:true];
    [pickerBtn setEnabled:false];
    
    [content setFrame:CGRectMake(0, 78, 320, 382)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setScrollsToTop:YES];
    
}


- (IBAction) backgroundTouched:(id)sender
{
    [momentDesc resignFirstResponder];
    [occPickerView setHidden:TRUE];
    [content setFrame:CGRectMake(0, 78, 320, 382)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setScrollsToTop:YES];
}


- (void) setImage:(UIImage *)_img
{
    NSLog(@"image set...");
    [camPic setContentMode:UIViewContentModeScaleAspectFit];
    camPic.image = [_img retain];
    
}

-(void)textViewDidBeginEditing:(UITextView *)textView
{
    
    [content setFrame:CGRectMake(0, 78, 320, 160)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setContentOffset:CGPointMake(0, 240) animated:YES];
}

-(void)textViewDidEndEditing:(UITextView *)textView
{
    
    [content setFrame:CGRectMake(0, 78, 320, 382)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setScrollsToTop:YES];
}

- (IBAction) occasionPicker:(id)sender
{
    //NSLog(@"clicked.....");
    [momentDesc resignFirstResponder];
        
    //CGRect pickerRect = CGRectMake(0, 244, 320, 216);
    //[occPickerView setBounds:pickerRect];
    [occPickerView setHidden:FALSE];
    
    [pickerBtn setEnabled:TRUE];
    
    [content setFrame:CGRectMake(0, 78, 320, 166)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setScrollsToTop:YES];
        
}

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView;
{
    return 1;
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    occasionTopic.text=    [arrayNo objectAtIndex:row];
    oid.text = [oidArr objectAtIndex:row];
    
    /*
    [occPickerView setHidden:TRUE];
    
    [content setFrame:CGRectMake(0, 78, 320, 382)];
    [content setContentSize:CGSizeMake(320, 382)];
    [content setScrollsToTop:YES];
    */
    
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component;
{
    return [arrayNo count];
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component;
{
    return [arrayNo objectAtIndex:row];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [uploadResponse appendData:data];
    NSLog(@"receiving data");
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"data error");
    uploadResponse = nil;
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSString *jsonStr = [[NSString alloc] initWithData:uploadResponse encoding:NSUTF8StringEncoding];
    NSLog(@"response:    %@", jsonStr);
    //[photogether disposeLoadingView:self.view];
    uploadResponse = nil;
}


-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    
    if( [response respondsToSelector:@selector(statusCode)] )
    {
        int statusCode = [(NSHTTPURLResponse *) response statusCode];
        NSDictionary *allheader = [(NSHTTPURLResponse *) response allHeaderFields];
        if ([response respondsToSelector:@selector(allHeaderFields)])
        {
            
            for (id key in allheader) {
                
                NSLog(@"key: %@, value: %@", key, [allheader objectForKey:key]);
                
            }
            
        }
        if( statusCode == 200 )
        {
            // login success
            NSLog(@"upload success: 200");
            
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Upload Completed!" 
                                                           delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
            [alert show];
            [alert release];  
            
        }else
        {
            // login failure
            NSLog(@"upload code : %i", statusCode);
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Upload Failure!" 
                                                           delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
            [alert show];
            [alert release];  
            
        }
        allheader = nil;
        
    }
    //[photogether disposeLoadingView:self.view];
    
    
}


- (IBAction)uploadAction:(id)sender
{
    [NSThread detachNewThreadSelector:@selector(postImage:) 
                             toTarget:self 
                           withObject:camPic.image];
    //[self postImage:camPic.image];
    
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Upload Completed!" 
                                                   delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
    [alert release];  

}

-(void)postImage:(UIImage*)theImage
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSString *url = [NSString stringWithFormat: @"http://www.photogether.co/mobile/fileupload/%@/uploadfile.htm", oid.text];
    
    NSTimeInterval timeStamp = [[NSDate date] timeIntervalSince1970];
    // NSTimeInterval is defined as double
    NSNumber *timeStampObj = [NSNumber numberWithDouble: timeStamp];
    
    NSString *imgName = [NSString stringWithFormat:@"%d.JPG", timeStampObj];
    
    NSLog(@"%@ image file generated.", imgName);
    
    NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
    [request setURL:[NSURL URLWithString:url]];
    [request setHTTPMethod:@"POST"];
    
    /*
     Set Header and content type of your request.
     */
    NSString *boundary = [NSString stringWithString:@"---------------------------Boundary Line---------------------------"];
    NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
    [request addValue:contentType forHTTPHeaderField: @"Content-Type"];
    
    /*
     now lets create the body of the request.
     */
    NSMutableData *body = [NSMutableData data];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];    
    [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"userfile\"; filename=\"%@\"\r\n", imgName] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithString:@"Content-Type: image/jpeg\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[NSData dataWithData:UIImageJPEGRepresentation(theImage, 90)]];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    //[body appendData:[[NSString stringWithFormat:@"geotag=%@&", [self _currentLocationMetadata]] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    
    // set body with request.
    [request setHTTPBody:body];
    [request addValue:[NSString stringWithFormat:@"%d", [body length]] forHTTPHeaderField:@"Content-Length"];
    
    // now lets make the connection to the web
    [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
    
    [pool release];
}


-(IBAction)backAction:(id)sender
{
    [self dismissModalViewControllerAnimated:NO];
}



-(void) loadTopics
{
    NSString *occ_json = [photogether getJSON:@"http://www.photogether.co/mobile/occasions.htm"];
    
    NSLog(@"%@", occ_json);
    
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *statuses = [parser objectWithString:occ_json error:nil];
    
     
    for (NSDictionary *occ_status in statuses)
    {
        NSString *o_id = [occ_status objectForKey:@"id"];
        NSString *o_topic = [occ_status objectForKey:@"occasionTopic"];
        //NSLog(@"%@", o_topic);
        //add to picker array
        [arrayNo addObject:o_topic];
        [oidArr addObject:o_id];
          
    }
    
    //set to the first occasion topic
    if( [arrayNo count] > 0){
        occasionTopic.text = [arrayNo objectAtIndex:0];
        oid.text = [ oidArr objectAtIndex:0];
    }
    
    statuses = nil;
    [parser release];
    occ_json = nil;
    
    
    
}



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    arrayNo = [[NSMutableArray alloc] init];
    oidArr = [[NSMutableArray alloc] init];
    
    photogether = [[Photogether alloc] init];
    uploadResponse = [NSMutableData data];
    
    //load occasion topics to picker view
    [self loadTopics];
    
    //load 
    //[arrayNo addObject:@"PUBLIC"];
    //[arrayNo addObject:@"PRIVATE"];
    if( [arrayNo count] > 0 ){
        [occPickerView selectRow:1 inComponent:0 animated:NO];
        occasionTopic.text= [arrayNo objectAtIndex:[occPickerView selectedRowInComponent:0]];  
    }
    
    [profile setImage:[photogether loadProfilePic:[[NSUserDefaults standardUserDefaults] objectForKey:@"PTusername" ]] ];

}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    uploadResponse = nil;
    
    [photogether release];
    arrayNo = nil;
    oidArr = nil;
    
    [camPic release];
    [occPickerView release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
